<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_schedule".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderSchedule".
 *
 * Columns in table "provider_schedule" available as properties of the model,
 * followed by relations of table "provider_schedule" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property integer $day_number
 * @property string $hours
 *
 * @property Provider $provider
 */
abstract class BaseProviderSchedule extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_schedule';
    }

    public static function representingColumn()
    {
        return 'day_number';
    }

    public function rules()
    {
        return array(
            array('provider_id, day_number', 'required'),
            array('provider_id, day_number', 'numerical', 'integerOnly' => true),
            array('hours', 'length', 'max' => 50),
            array('hours', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, day_number, hours', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'day_number' => Yii::t('app', 'Weekday'),
            'hours' => Yii::t('app', 'Hours'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('day_number', $this->day_number);
        $criteria->compare('hours', $this->hours, true);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderSchedule|ProviderSchedules', $n);
    }

}
